package rocks.zipcode.io.quiz4.fundamentals;

import java.util.ArrayList;
import java.util.List;

/**
 * @author leon on 18/12/2018.
 */
public class PalindromeEvaluator {
    public static String[] getAllPalindromes(String string) {

        List<String> list = new ArrayList<String>();

        for (float pivot = 0; pivot < string.length(); pivot += .5) {


            float palindromeRadius = pivot - (int)pivot;


            while ((pivot + palindromeRadius) < string.length()
                    && (pivot - palindromeRadius) >= 0
                    && string.charAt((int)(pivot - palindromeRadius))
                    == string.charAt((int)(pivot + palindromeRadius))) {
                if( !list.contains(string.substring((int)(pivot - palindromeRadius),
                        (int)(pivot + palindromeRadius + 1)))) {
                    list.add(string.substring((int) (pivot - palindromeRadius),
                            (int) (pivot + palindromeRadius + 1)));
                }
                palindromeRadius++;
            }
        }

        return list.toArray(new String[0]);
    }

    public static Boolean isPalindrome(String string) {
        if(string.equals(reverseString(string))){
            return true;
        }
        return false;
    }

    public static String reverseString(String string) {
        StringBuilder sb = new StringBuilder();
        sb.append(string);
        return sb.reverse().toString();
    }
}
